    nomainwin
    Data "00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24"
    Data "00","05","10","15","20","25","30","35","40","45","50","55"
    Dim HourArray$(24), MinuteArray$(12), ReportArray$(1)
    for i=0 to 24 : read temp$ : HourArray$(i)=temp$ : next
    for i=0 to 11 : read temp$ : MinuteArray$(i)=temp$ : next i
    WindowWidth = 1080
    WindowHeight = 490
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)
    statictext #main.LogFileSummary, "", 150, 20, 240, 80
    statictext #main.Zoom, "24hr", 750, 5, 240, 20
    statictext #main.ZoomStart, "00:00", 435, 5, 240, 20
    statictext #main.ZoomEnd, "24:00", 1035, 5, 240, 20
    BUTTON #main.OpenFile, "Open File", [OpenFile], UL, 5, 5 , 100, 25
    graphicbox #main.Graph, 450, 25, 600, 420
    statictext #main.txt1, "From", 5, 43, 30, 20
    statictext #main.txt2, "To", 5, 68, 30, 20
    combobox #main.StartHour, HourArray$(), [PlotGraph],  40,  40, 40, 20
    combobox #main.StartMinute, MinuteArray$(), [PlotGraph],  85,  40, 40, 20
    combobox #main.EndHour, HourArray$(), [PlotGraph],  40,  65, 40, 20
    combobox #main.EndMinute, MinuteArray$(), [PlotGraph],  85,  65, 40, 20
    listbox #main.Report, ReportArray$(), [DoNothing], 5, 130, 430, 160
    checkbox #main.DisplayVolts, "Volts", [PlotGraph], [PlotGraph], 35,  300,  82,  20
    statictext #main.MouseVolts, "", 130,  303,  82,  20
    graphicbox #main.Box1, 15, 302, 15, 15
    checkbox #main.DisplayAmps, "Amps", [PlotGraph], [PlotGraph], 35,  320,  82,  20
    statictext #main.MouseAmps, "", 130,  323,  82,  20
    graphicbox #main.Box2, 15, 322, 15, 15
    checkbox #main.DisplayWatts, "Watts", [PlotGraph], [PlotGraph], 35,  340,  82,  20
    statictext #main.MouseWatts, "", 130,  343,  82,  20
    graphicbox #main.Box3, 15, 342, 15, 15
    checkbox #main.DisplayWindSpeed, "Wind Speed", [PlotGraph], [PlotGraph], 35,  360,  90,  20
    statictext #main.MouseWindSpeed, "", 130,  363,  82,  20
    graphicbox #main.Box4, 15, 362, 15, 15
    checkbox #main.DisplayRPM, "RPM", [PlotGraph], [PlotGraph], 35,  380,  82,  20
    statictext #main.MouseRPM, "", 130,  383,  82,  20
    graphicbox #main.Box5, 15, 382, 15, 15
    checkbox #main.Smooth, "Smooth Graph", [PlotGraph], [PlotGraph], 35,  410,  120,  20
    statictext #main.txt3, "Time       Volts    Amps   Watts  W'Speed    RPM     Wh", 10, 115, 430, 15

    open "PicGraph 1.0.b" for window as #main

    print #main.txt3, "!font courier_new 8"
    'PRINT #main.Report, "!font courier_new 8"
    print #main.StartHour, "select 00"
    print #main.StartMinute, "select 00"
    print #main.EndHour, "select 24"
    print #main.EndMinute, "select 00"
    print #main.DisplayWatts, "set"

    print #main.Graph, "backcolor 0 0 0"
    print #main.Box1, "backcolor 127 127 127"  'V
    print #main.Box2, "backcolor 0 128 255" 'A
    print #main.Box3, "backcolor 192 127 0" 'W
    print #main.Box4, "backcolor 0 255 0" 'WS
    print #main.Box5, "backcolor 128 128 255" 'RPM

    print #main.Graph, "when leftButtonDown [ZoomIn]"
    print #main.Graph, "when rightButtonDown [ZoomOut]"
    print #main.Graph, "when mouseMove [GraphPos]"

    print #main, "trapclose [quit]"

    T1$=ColFormat$("Time",10)
    T2$=ColFormat$("Volts", 10)
    'print #main.Report, T1$+T2$
    'print #main.Report, "Time Volts Amps Watt WindSpeed RPM Wh"

    Dim VoltArray(1), AmpArray(1), WattArray(1), RPMArray(1), WindSpeedArray(1), WattHoursArray(1), TimeArray$(1), SecondsArray(1)

    Wait

[OpenFile]

filedialog "Open log file. Look in the Logfiles directory.", "*.txt", LogFileName$
if LogFileName$="" then
    notice "No file chosen!"
else
    RecordCount=0
    open LogFileName$ for input as #f
        while eof(#f) = 0
            line input #f, LogFileEntry$
            RecordCount=RecordCount+1
        wend
    close #f
    redim VoltArray(RecordCount)
    redim AmpArray(RecordCount)
    redim WattArray(RecordCount)
    redim RPMArray(RecordCount)
    redim WindSpeedArray(RecordCount)
    redim WattHoursArray(RecordCount)
    redim TimeArray$(RecordCount)
    redim SecondsArray(RecordCount)
    i=0
    open LogFileName$ for input as #f
        while eof(#f) = 0
            i=i+1
            Dot$=""
            for x=1 to int(i/50)
                Dot$=Dot$+". "
            next
            print #main.LogFileSummary, "Loading" + Dot$
            line input #f, LogFileEntry$ 
            If InStr(LogFileEntry$, "<V>") > 0 And InStr(LogFileEntry$, "</V>") > InStr(LogFileEntry$, "<V>") Then VoltArray(i) = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<V>") + 3, InStr(LogFileEntry$, "</V>") - InStr(LogFileEntry$, "<V>") - 3)) else VoltArray(i)=0
            If InStr(LogFileEntry$, "<I>") > 0 And InStr(LogFileEntry$, "</I>") > InStr(LogFileEntry$, "<I>") Then AmpArray(i) = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<I>") + 3, InStr(LogFileEntry$, "</I>") - InStr(LogFileEntry$, "<I>") - 3)) else AmpArray(i)=0
            If InStr(LogFileEntry$, "<W>") > 0 And InStr(LogFileEntry$, "</W>") > InStr(LogFileEntry$, "<W>") Then WattArray(i) = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<W>") + 3, InStr(LogFileEntry$, "</W>") - InStr(LogFileEntry$, "<W>") - 3)) else WattArray(i)=0
            If InStr(LogFileEntry$, "<R>") > 0 And InStr(LogFileEntry$, "</R>") > InStr(LogFileEntry$, "<R>") Then RPMArray(i) = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<R>") + 3, InStr(LogFileEntry$, "</R>") - InStr(LogFileEntry$, "<R>") - 3)) else RPMArray(i)=0
            If InStr(LogFileEntry$, "<S>") > 0 And InStr(LogFileEntry$, "</S>") > InStr(LogFileEntry$, "<S>") Then WindSpeedArray(i) = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<S>") + 3, InStr(LogFileEntry$, "</S>") - InStr(LogFileEntry$, "<S>") - 3)) else WindSpeedArray(i)=0
            If InStr(LogFileEntry$, "<Wh>") > 0 And InStr(LogFileEntry$, "</Wh>") > InStr(LogFileEntry$, "<Wh>") Then WattHoursArray(i) = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<Wh>") + 4, InStr(LogFileEntry$, "</Wh>") - InStr(LogFileEntry$, "<Wh>") - 4)) else WattHoursArray(i)=0
            If InStr(LogFileEntry$, "<T>") > 0 And InStr(LogFileEntry$, "</T>") > InStr(LogFileEntry$, "<T>") Then TimeArray$(i) = Mid$(LogFileEntry$, InStr(LogFileEntry$, "<T>") + 3, InStr(LogFileEntry$, "</T>") - InStr(LogFileEntry$, "<T>") - 3) else TimeArray$(i)="12:00:00"
            SecondsArray(i)=GetSeconds(TimeArray$(i))
        wend
    close #f
    MaxVolts=0
    MinVolts=1000
    MaxAmps=0
    MaxWatts=0
    MaxWattsTime$=""
    MaxRPM=0
    MaxWindSpeed=0
    WattHours=0
    for i=1 to RecordCount
        if VoltArray(i)>MaxVolts then MaxVolts=VoltArray(i)
        if VoltArray(i)<MinVolts then MinVolts=VoltArray(i)
        if AmpArray(i)>MaxAmps then MaxAmps=AmpArray(i)
        if RPMArray(i)>MaxRPM then MaxRPM=RPMArray(i)
        if WindSpeedArray(i)>MaxWindSpeed then MaxWindSpeed=WindSpeedArray(i)
        if WattArray(i)>MaxWatts then
            MaxWatts=WattArray(i)
            MaxWattsTime$=TimeArray$(i)
        end if
    next
    print #main.StartHour, "select 00"
    print #main.StartMinute, "select 00"
    print #main.EndHour, "select 24"
    print #main.EndMinute, "select 00"
    WattHours=WattHoursArray(RecordCount)
    Summary$="Date " + replace$(strippath$(LogFileName$),"_","/") + chr$(13) + chr$(13)
    Summary$=Summary$ + str$(RecordCount) + " records." + chr$(13) + chr$(13)
    Summary$=Summary$ + "Max " + str$(MaxWatts) + "W at " + MaxWattsTime$ + chr$(13) + chr$(13)
    Summary$=Summary$ + str$(WattHours) + "Wh for the day"
    print #main.LogFileSummary, Summary$
    ZoomFactor$="24hr"
    goto [PlotGraph]

end if

wait

[PlotGraph]
    If RecordCount=0 then wait
    ' Get the start and finish times
    print #main.StartHour, "contents? temp1$"
    print #main.StartMinute, "contents? temp2$"
    StartTime$=temp1$ + ":" + temp2$
    StartTimeSeconds=GetSeconds(StartTime$)
    print #main.EndHour, "contents? temp1$"
    print #main.EndMinute, "contents? temp2$"
    EndTime$=temp1$ + ":" + temp2$
    EndTimeSeconds=GetSeconds(EndTime$)
    ' Work out our start and finish position
    StartPos=0
    EndPos=RecordCount
    for i=0 to RecordCount
        if SecondsArray(i)>=StartTimeSeconds and StartPos=0 then StartPos=i
        if SecondsArray(i)>=EndTimeSeconds and EndPos=RecordCount then EndPos=i
    next
    print #main.Zoom, ZoomFactor$
    print #main.ZoomStart, StartTime$
    print #main.ZoomEnd, EndTime$
    Range=EndPos-StartPos
    print #main.Smooth, "value? temp$"
    if temp$="set" then Smoothing=int(2/(600/Range)) else Smoothing=0
    print #main.Graph, "cls"
    print #main.Graph, "fill 0 0 0"
    print #main.DisplayWatts, "value? temp$"
    if temp$="set" then
        print #main.Graph, "color 192 127 0"
        print #main.Graph, "goto 0 " + str$(410-(WattArray(StartPos)/MaxWatts*400))
        print #main.Graph, "down"
        if Smoothing>0 then
            for i=StartPos to EndPos step Smoothing
                Av=0
                for k=i to i+Smoothing
                    Av=Av+WattArray(i)
                next
                Av=Av/(Smoothing+1)
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(Av/MaxWatts*400))
            next
        else
            for i=StartPos to EndPos
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(WattArray(i)/MaxWatts*400))
            next
        end if
        print #main.Graph, "up"
        print #main.Graph, "flush"
    end if
    print #main.DisplayAmps, "value? temp$"
    if temp$="set" then
        print #main.Graph, "color 00 128 255"
        print #main.Graph, "goto 0 " + str$(410-(AmpArray(1)/MaxAmps*400))
        print #main.Graph, "down"
        if Smoothing>0 then
            for i=StartPos to EndPos step Smoothing
                Av=0
                for k=i to i+Smoothing
                    Av=Av+AmpArray(i)
                next
                Av=Av/(Smoothing+1)
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(Av/MaxAmps*400))
            next
        else
            for i=StartPos to EndPos
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(AmpArray(i)/MaxAmps*400))
            next
        end if
        print #main.Graph, "up"
        print #main.Graph, "flush"
    end if
    print #main.DisplayRPM, "value? temp$"
    if temp$="set" and MaxRPM>0 then
        print #main.Graph, "color 128 128 255"
        print #main.Graph, "goto 0 " + str$(410-(RPMArray(1)/MaxRPM*400))
        print #main.Graph, "down"
        if Smoothing>0 then
            for i=StartPos to EndPos step Smoothing
                Av=0
                for k=i to i+Smoothing
                    Av=Av+RPMArray(i)
                next
                Av=Av/(Smoothing+1)
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(Av/MaxRPM*400))
            next
        else
            for i=StartPos to EndPos
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(RPMArray(i)/MaxRPM*400))
            next
        end if
        print #main.Graph, "up"
        print #main.Graph, "flush"
    end if
    print #main.DisplayWindSpeed, "value? temp$"
    if temp$="set" and MaxWindSpeed>0 then
        print #main.Graph, "color 0 255 0"
        print #main.Graph, "goto 0 " + str$(410-(WindSpeedArray(1)/MaxWindSpeed*400))
        print #main.Graph, "down"
        if Smoothing>0 then
            for i=StartPos to EndPos step Smoothing
                Av=0
                for k=i to i+Smoothing
                    Av=Av+WindSpeedArray(i)
                next
                Av=Av/(Smoothing+1)
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(Av/MaxWindSpeed*400))
            next
        else
            for i=StartPos to EndPos
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(WindSpeedArray(i)/MaxWindSpeed*400))
            next
        end if
        print #main.Graph, "up"
        print #main.Graph, "flush"
    end if
    print #main.DisplayVolts, "value? temp$"
    if temp$="set" then
        print #main.Graph, "color 128 128 128"
        print #main.Graph, "goto 0 " + str$(410-(VoltArray(1)/MaxVolts*400))
        print #main.Graph, "down"
        if Smoothing>0 then
            for i=StartPos to EndPos step Smoothing
                Av=0
                for k=i to i+Smoothing
                    Av=Av+VoltArray(i)
                next
                Av=Av/(Smoothing+1)
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(Av/MaxVolts*400))
            next
        else
            for i=StartPos to EndPos
                print #main.Graph, "goto " + str$(600/Range*(i-StartPos)) + " " + str$(410-(VoltArray(i)/MaxVolts*400))
            next
        end if
        print #main.Graph, "up"
        print #main.Graph, "flush"
    end if
    gosub [ReportScreenData]
wait

[ReportScreenData]

    redim ReportArray$(EndPos+5)
    print #main.Report, "font courier_new 8"
    for i=StartPos to EndPos
        ReportArray$(i+3)=ColFormat$(TimeArray$(i),8)+ColFormat$(using("###.##",VoltArray(i)),8)+ColFormat$(using("###.##",AmpArray(i)),8)+ColFormat$(using("####.##",WattArray(i)),8)+ColFormat$(using("###.#",WindSpeedArray(i)),8)+ColFormat$(using("####.#",RPMArray(i)),8)+ColFormat$(using("#####.#",WattHoursArray(i)),8)
    next
    print #main.Report, "reload"
Return

[ClearData]
    'cls
wait

[ZoomIn]
    ZoomX=MouseX
    RecordPos=StartPos+int((EndPos-StartPos)/600*MouseX)
    RecordTime=SecondsArray(RecordPos)
    Select Case ZoomFactor$
        Case "24hr"
            NewZoomFactor$="6hr"
            StartTimeSeconds=RecordTime-10800
            if StartTimeSeconds<0 then StartTimeSeconds=0
            EndTimeSeconds=RecordTime+10800
            if EndTimeSeconds>86400 then EndTimeSeconds=86400
            call SetStartTime StartTimeSeconds
            call SetEndTime EndTimeSeconds
        Case "6hr"
            NewZoomFactor$="1hr"
            StartTimeSeconds=RecordTime-1800
            if StartTimeSeconds<0 then StartTimeSeconds=0
            EndTimeSeconds=RecordTime+1800
            if EndTimeSeconds>86400 then EndTimeSeconds=86400
            call SetStartTime StartTimeSeconds
            call SetEndTime EndTimeSeconds
        Case "1hr"
            NewZoomFactor$="30min"
            StartTimeSeconds=RecordTime-900
            if StartTimeSeconds<0 then StartTimeSeconds=0
            EndTimeSeconds=RecordTime+900
            if EndTimeSeconds>86400 then EndTimeSeconds=86400
            call SetStartTime StartTimeSeconds
            call SetEndTime EndTimeSeconds
        Case "30min"
            NewZoomFactor$="30min"
            ' Do nothing, zoomed in as far as we need to.
        Case Else
            NewZoomFactor$="24hr"
            print #main.StartHour, "select 00"
            print #main.StartMinute, "select 00"
            print #main.EndHour, "select 24"
            print #main.EndMinute, "select 00"
    End Select
    ZoomFactor$=NewZoomFactor$
    goto [PlotGraph]

wait

[ZoomOut]
    ZoomX=MouseX
    RecordPos=StartPos+int((EndPos-StartPos)/600*MouseX)
    RecordTime=SecondsArray(RecordPos)
    Select Case ZoomFactor$
        Case "24hr"
            NewZoomFactor$="24hr"
            ' Do Nothing, zoomed out as far as we can go.
        Case "6hr"
            NewZoomFactor$="24hr"
            print #main.StartHour, "select 00"
            print #main.StartMinute, "select 00"
            print #main.EndHour, "select 24"
            print #main.EndMinute, "select 00"
        Case "1hr"
            NewZoomFactor$="6hr"
            StartTimeSeconds=RecordTime-10800
            if StartTimeSeconds<0 then StartTimeSeconds=0
            EndTimeSeconds=RecordTime+10800
            if EndTimeSeconds>86400 then EndTimeSeconds=86400
            call SetStartTime StartTimeSeconds
            call SetEndTime EndTimeSeconds
        Case "30min"
            NewZoomFactor$="1hr"
            StartTimeSeconds=RecordTime-1800
            if StartTimeSeconds<0 then StartTimeSeconds=0
            EndTimeSeconds=RecordTime+1800
            if EndTimeSeconds>86400 then EndTimeSeconds=86400
            call SetStartTime StartTimeSeconds
            call SetEndTime EndTimeSeconds
        Case Else
            NewZoomFactor$="24hr"
            print #main.StartHour, "select 00"
            print #main.StartMinute, "select 00"
            print #main.EndHour, "select 24"
            print #main.EndMinute, "select 00"
    End Select
    ZoomFactor$=NewZoomFactor$
    goto [PlotGraph]
wait

[GraphPos]
    if RecordCount=0 then wait
    RecordPos=StartPos+int((EndPos-StartPos)/600*MouseX)
    print #main.MouseVolts, VoltArray(RecordPos)
    print #main.MouseAmps, AmpArray(RecordPos)
    print #main.MouseWatts, WattArray(RecordPos)
    print #main.MouseWindSpeed, WindSpeedArray(RecordPos)
    print #main.MouseRPM, RPMArray(RecordPos)
wait


[quit]
    Close #main
END

function ColFormat$(text1$, num1)
    WHILE LEN(text1$)<num1                  'set length to 9 characters
        text1$=" " + text1$
    WEND
    ColFormat$=text1$
end function

function replace$(temp1$,temp2$,temp3$) 'JustBASIC doesn't have a REPLACE function, so we need to make our own
    if instr(temp1$,temp2$)=0 then
        replace$=temp1$
    else
        replace$=""
        do until instr(temp1$,temp2$)=0
            characterposition=instr(temp1$,temp2$)
            replace$=replace$ + left$(temp1$,characterposition-1) + temp3$
            temp1$=mid$(temp1$,characterposition+1)
        loop
        replace$=replace$+temp1$
    end if
end function

function strippath$(temp1$)
    do until instr(temp1$,"\")=0
        temp1$=mid$(temp1$,instr(temp1$,"\")+1)
    loop
    temp1$=left$(temp1$,instr(temp1$,"."))
    strippath$=temp1$
end function

function GetSeconds(temp1$)
    H=val(left$(temp1$,2))
    M=val(mid$(temp1$,4,2))
    S=val(right$(temp1$,2))
    GetSeconds=(H*3600)+(M*60)+S
end function

sub SetStartTime temp2
    Hour=int(temp2/3600)
    Minute=int((temp2-(Hour*3600))/300)
    print #main.StartHour, "select " + HourArray$(Hour)
    print #main.StartMinute, "select " +  MinuteArray$(Minute)
end sub

sub SetEndTime temp2
    Hour=int(temp2/3600)
    Minute=int((temp2-(Hour*3600))/300)
    print #main.EndHour, "select " + HourArray$(Hour)
    print #main.EndMinute, "select " +  MinuteArray$(Minute)
end sub


[DoNothing]
wait
